/*
  ytDoubleArray.{h,c} : Double float Array
  Copyright (C) 2016, Yoshinori Tamada <tamada  A T ytlab.jp>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright 
    notice, this list of conditions and the following disclaimer in 
    the documentation and/or other materials provided with the 
    distribution.

  * Neither the name of The University of Tokyo nor the names of its 
    contributors may be used to endorse or promote products derived 
    from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
  FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
  COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __YTLIB_DOUBLE_ARRAY_H
#define __YTLIB_DOUBLE_ARRAY_H

#include <stdio.h>
#include <stdlib.h>

typedef struct ytDoubleArray_t {
  double * ptr;
  size_t size;
  size_t buff_size;
} ytDoubleArray;

ytDoubleArray * ytDoubleArray_new();
void ytDoubleArray_delete(ytDoubleArray * this);
ytDoubleArray * ytDoubleArray_arrayNew(size_t size);
size_t ytDoubleArray_size(const ytDoubleArray * this);
void ytDoubleArray_clear(ytDoubleArray * this);
void ytDoubleArray_add(ytDoubleArray * this, double value);
void ytDoubleArray_set(ytDoubleArray * this, size_t index, double value);
double ytDoubleArray_get(const ytDoubleArray * this, size_t index);
void ytDoubleArray_sort(ytDoubleArray * this);
void ytDoubleArray_print(ytDoubleArray * this, FILE * fp, char * delim);

#endif /* __YTLIB_DOUBLE_ARRAY_H */
